#ifndef _ZOMBIE_H_
#define _ZOMBIE_H_

#include <string>
#include <iostream>
#include "gameCharacter.h"
#include "gameObject.h"

using namespace std;

class Zombie : public gameCharacter, public gameObject {
  private:
    bool sleepy;
    
  public:
    Zombie(int pHP, int pSpeed, string pName, bool pSleepy, int pX) :
	  gameObject(pX),
	  gameCharacter(pHP, pSpeed, pName),
	  sleepy(pSleepy)
    {
	// sleepy = pSleepy;
    }
    
    void wakeUp() {
        sleepy = false;
    }
  
    void sleep() {
	sleepy = true;
    }
    
    void moveForward() {
	if (!sleepy)
	    this->setPosX( this->getPosX() + this->getSpeed() );  
    }
    
    void moveBackwards() {
	if (!sleepy)
	    this->setPosX( this->getPosX() - this->getSpeed() );
    }
    
    void printCharacter() {
	cout << endl;
	
	for (int i=1; i < getPosX()+1; i++) {
	    cout << " ";
	}
	if (!sleepy)
	    cout << "o" << endl;
	else	  
	    cout << "=" << endl;
	
	for (int i=1; i < getPosX(); i++) {
	    cout << " ";
	}
	cout << "-|-" << endl;
	
	for (int i=1; i < getPosX()+1; i++) {
	    cout << " ";
	}
	cout << "^" << endl << endl;	
    }
};

#endif