#include <iostream>
using namespace std;

class CPolygon {
  public:
    // funcao virtual pura
    // uma classe que contem pelo menos uma funcao virtual pura e uma classe abstrata
    virtual void set_values (int, int) = 0;
    virtual void set_value (int) = 0;
    virtual int area () = 0;
};


class CCircle: public CPolygon {
  protected:
    int radius;
    
  public:
    virtual void set_values (int a, int b) { ; }
    
    void set_value (int a) {
       radius = a; 
    }
    
    int area ()
      { return (3.1415*(radius*radius)); }
};

class CRectangle: public CPolygon {
  protected:
    int width, height;
  public:
    
    virtual void set_value (int a) { ; }
    
    
    void set_values (int a, int b) {
       width=a; height=b; 
    }
    int area ()
      { return (width * height); }
};

class CTriangle: public CPolygon {
  protected:
    int width, height;  
  public:
    virtual void set_value (int a) { ; }
        
    void set_values (int a, int b) {
       width=a; height=b; 
    }
    int area ()
      { return (width * height / 2); }
};

int main (int argc, char *argv[]) {
  CRectangle rect;
  CTriangle trgl;
  CCircle circ;
  
  CPolygon * ppoly1 = &rect;
  CPolygon * ppoly2 = &trgl;
  CPolygon * ppoly3 = &circ;
  
  ppoly1->set_values (4,5); // static binding - o compilador resolve de forma estatica 
  ppoly2->set_values (4,5); // static binding - o compilador resolve de forma estatica 
  ppoly3->set_value (5);
  ppoly3->set_values (5,4);
  
  // area e virtual, e portanto
  cout << ppoly1->area() << endl;  // dynamic binding - so sera resolvido em tempo de execucao
  cout << ppoly2->area() << endl; // dynamic binding - so sera resolvido em tempo de execucao
  cout << ppoly3->area() << endl; // dynamic binding - so sera resolvido em tempo de execucao
  return 0;
}